diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/channel-access-manager.cc ns-3.40/src/wifi/model/channel-access-manager.cc
--- ns-3.39/src/wifi/model/channel-access-manager.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/channel-access-manager.cc	2023-09-27 13:30:37.902840000 -0700
@@ -19,14 +19,16 @@
 
 #include "channel-access-manager.h"
 
-#include "frame-exchange-manager.h"
 #include "txop.h"
 #include "wifi-phy-listener.h"
 #include "wifi-phy.h"
 
+#include "ns3/eht-frame-exchange-manager.h"
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 
+#include <sstream>
+
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "] "
 
@@ -36,7 +38,11 @@
 NS_LOG_COMPONENT_DEFINE("ChannelAccessManager");
 
 /**
- * Listener for PHY events. Forwards to ChannelAccessManager
+ * Listener for PHY events. Forwards to ChannelAccessManager.
+ * The ChannelAccessManager may handle multiple PHY listeners connected to distinct PHYs,
+ * but only one listener at a time can be active. Notifications from inactive listeners are
+ * ignored by the ChannelAccessManager, except for the channel switch notification.
+ * Inactive PHY listeners are typically configured by 11be EMLSR clients.
  */
 class PhyListener : public ns3::WifiPhyListener
 {
@@ -47,7 +53,8 @@
      * \param cam the ChannelAccessManager
      */
     PhyListener(ns3::ChannelAccessManager* cam)
-        : m_cam(cam)
+        : m_cam(cam),
+          m_active(true)
     {
     }
 
@@ -55,60 +62,106 @@
     {
     }
 
+    /**
+     * Set this listener to be active or not.
+     *
+     * \param active whether this listener is active or not
+     */
+    void SetActive(bool active)
+    {
+        m_active = active;
+    }
+
+    /**
+     * \return whether this listener is active or not
+     */
+    bool IsActive() const
+    {
+        return m_active;
+    }
+
     void NotifyRxStart(Time duration) override
     {
-        m_cam->NotifyRxStartNow(duration);
+        if (m_active)
+        {
+            m_cam->NotifyRxStartNow(duration);
+        }
     }
 
     void NotifyRxEndOk() override
     {
-        m_cam->NotifyRxEndOkNow();
+        if (m_active)
+        {
+            m_cam->NotifyRxEndOkNow();
+        }
     }
 
     void NotifyRxEndError() override
     {
-        m_cam->NotifyRxEndErrorNow();
+        if (m_active)
+        {
+            m_cam->NotifyRxEndErrorNow();
+        }
     }
 
     void NotifyTxStart(Time duration, double txPowerDbm) override
     {
-        m_cam->NotifyTxStartNow(duration);
+        if (m_active)
+        {
+            m_cam->NotifyTxStartNow(duration);
+        }
     }
 
     void NotifyCcaBusyStart(Time duration,
                             WifiChannelListType channelType,
                             const std::vector<Time>& per20MhzDurations) override
     {
-        m_cam->NotifyCcaBusyStartNow(duration, channelType, per20MhzDurations);
+        if (m_active)
+        {
+            m_cam->NotifyCcaBusyStartNow(duration, channelType, per20MhzDurations);
+        }
     }
 
     void NotifySwitchingStart(Time duration) override
     {
-        m_cam->NotifySwitchingStartNow(duration);
+        m_cam->NotifySwitchingStartNow(this, duration);
     }
 
     void NotifySleep() override
     {
-        m_cam->NotifySleepNow();
+        if (m_active)
+        {
+            m_cam->NotifySleepNow();
+        }
     }
 
     void NotifyOff() override
     {
-        m_cam->NotifyOffNow();
+        if (m_active)
+        {
+            m_cam->NotifyOffNow();
+        }
     }
 
     void NotifyWakeup() override
     {
-        m_cam->NotifyWakeupNow();
+        if (m_active)
+        {
+            m_cam->NotifyWakeupNow();
+        }
     }
 
     void NotifyOn() override
     {
-        m_cam->NotifyOnNow();
+        if (m_active)
+        {
+            m_cam->NotifyOnNow();
+        }
     }
 
   private:
     ns3::ChannelAccessManager* m_cam; //!< ChannelAccessManager to forward events to
+    bool m_active;                    //!< whether this PHY listener is active
 };
 
 /****************************************************************
@@ -116,16 +169,17 @@
  ****************************************************************/
 
 ChannelAccessManager::ChannelAccessManager()
-    : m_lastAckTimeoutEnd(MicroSeconds(0)),
-      m_lastCtsTimeoutEnd(MicroSeconds(0)),
-      m_lastNavEnd(MicroSeconds(0)),
+    : m_lastAckTimeoutEnd(0),
+      m_lastCtsTimeoutEnd(0),
+      m_lastNavEnd(0),
       m_lastRx({MicroSeconds(0), MicroSeconds(0)}),
       m_lastRxReceivedOk(true),
-      m_lastTxEnd(MicroSeconds(0)),
-      m_lastSwitchingEnd(MicroSeconds(0)),
+      m_lastTxEnd(0),
+      m_lastSwitchingEnd(0),
+      m_usingOtherEmlsrLink(false),
+      m_lastUsingOtherEmlsrLinkEnd(0),
       m_sleeping(false),
       m_off(false),
-      m_phyListener(nullptr),
       m_linkId(0)
 {
     NS_LOG_FUNCTION(this);
@@ -135,8 +189,6 @@
 ChannelAccessManager::~ChannelAccessManager()
 {
     NS_LOG_FUNCTION(this);
-    delete m_phyListener;
-    m_phyListener = nullptr;
 }
 
 void
@@ -157,33 +209,96 @@
     }
     m_phy = nullptr;
     m_feManager = nullptr;
+    m_phyListeners.clear();
+}
+
+PhyListener*
+ChannelAccessManager::GetPhyListener(Ptr<WifiPhy> phy) const
+{
+    if (auto listenerIt = m_phyListeners.find(phy); listenerIt != m_phyListeners.end())
+    {
+        return listenerIt->second.get();
+    }
+    return nullptr;
 }
 
 void
 ChannelAccessManager::SetupPhyListener(Ptr<WifiPhy> phy)
 {
     NS_LOG_FUNCTION(this << phy);
-    NS_ASSERT(m_phyListener == nullptr);
-    m_phyListener = new PhyListener(this);
-    phy->RegisterListener(m_phyListener);
-    m_phy = phy;
+
+    auto phyListener = GetPhyListener(phy);
+
+    if (phyListener)
+    {
+        // a PHY listener for the given PHY already exists, it must be inactive
+        NS_ASSERT_MSG(!phyListener->IsActive(),
+                      "There is already an active listener registered for given PHY");
+        NS_ASSERT_MSG(!m_phy, "Cannot reactivate a listener if another PHY is active");
+        phyListener->SetActive(true);
+    }
+    else
+    {
+        phyListener = new PhyListener(this);
+        m_phyListeners.emplace(phy, phyListener);
+        phy->RegisterListener(phyListener);
+    }
+    if (m_phy)
+    {
+        DeactivatePhyListener(m_phy);
+    }
+    m_phy = phy; // this is the new active PHY
     InitLastBusyStructs();
+    if (phy->IsStateSwitching())
+    {
+        auto duration = phy->GetDelayUntilIdle();
+        NS_LOG_DEBUG("switching start for " << duration);
+        m_lastSwitchingEnd = Simulator::Now() + duration;
+    }
 }
 
 void
 ChannelAccessManager::RemovePhyListener(Ptr<WifiPhy> phy)
 {
     NS_LOG_FUNCTION(this << phy);
-    if (m_phyListener != nullptr)
+    if (auto phyListener = GetPhyListener(phy))
+    {
+        phy->UnregisterListener(phyListener);
+        m_phyListeners.erase(phy);
+        // reset m_phy if we are removing listener registered for the active PHY
+        if (m_phy == phy)
+        {
+            m_phy = nullptr;
+        }
+    }
+}
+
+void
+ChannelAccessManager::DeactivatePhyListener(Ptr<WifiPhy> phy)
+{
+    NS_LOG_FUNCTION(this << phy);
+    if (auto listener = GetPhyListener(phy))
+    {
+        listener->SetActive(false);
+    }
+    if (m_phy == phy)
     {
-        phy->UnregisterListener(m_phyListener);
-        delete m_phyListener;
-        m_phyListener = nullptr;
         m_phy = nullptr;
     }
 }
 
 void
+ChannelAccessManager::NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy,
+                                               const WifiPhyOperatingChannel& channel,
+                                               uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << phy << channel << linkId);
+    NS_ASSERT_MSG(m_switchingEmlsrLinks.count(phy) == 0,
+                  "The given PHY is already expected to switch channel");
+    m_switchingEmlsrLinks.emplace(phy, EmlsrLinkSwitchInfo{channel, linkId});
+}
+
+void
 ChannelAccessManager::SetLinkId(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << +linkId);
@@ -282,8 +397,8 @@
 {
     NS_LOG_FUNCTION(this << txop);
 
-    // No backoff needed if in sleep mode or off
-    if (m_sleeping || m_off)
+    // No backoff needed if in sleep mode, off or when using another EMLSR link
+    if (m_sleeping || m_off || m_usingOtherEmlsrLink)
     {
         return false;
     }
@@ -342,6 +457,11 @@
     {
         m_phy->NotifyChannelAccessRequested();
     }
+    if (m_usingOtherEmlsrLink)
+    {
+        NS_LOG_DEBUG("Channel access cannot be requested while using another EMLSR link");
+        return;
+    }
     // Deny access if in sleep mode or off
     if (m_sleeping || m_off)
     {
@@ -375,7 +495,7 @@
     NS_LOG_FUNCTION(this);
     uint32_t k = 0;
     Time now = Simulator::Now();
-    for (Txops::iterator i = m_txops.begin(); i != m_txops.end(); k++)
+    for (auto i = m_txops.begin(); i != m_txops.end(); k++)
     {
         Ptr<Txop> txop = *i;
         if (txop->GetAccessStatus(m_linkId) == Txop::REQUESTED &&
@@ -391,7 +511,7 @@
             i++; // go to the next item in the list.
             k++;
             std::vector<Ptr<Txop>> internalCollisionTxops;
-            for (Txops::iterator j = i; j != m_txops.end(); j++, k++)
+            for (auto j = i; j != m_txops.end(); j++, k++)
             {
                 Ptr<Txop> otherTxop = *j;
                 if (otherTxop->GetAccessStatus(m_linkId) == Txop::REQUESTED &&
@@ -475,6 +595,8 @@
     Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + sifs;
     Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + sifs;
     Time switchingAccessStart = m_lastSwitchingEnd + sifs;
+    Time usingOtherEmlsrLinkAccessStart =
+        (m_usingOtherEmlsrLink ? Simulator::Now() : m_lastUsingOtherEmlsrLinkEnd) + sifs;
     Time accessGrantedStart;
     if (ignoreNav)
     {
@@ -483,6 +605,7 @@
                                        txAccessStart,
                                        ackTimeoutAccessStart,
                                        ctsTimeoutAccessStart,
+                                       usingOtherEmlsrLinkAccessStart,
                                        switchingAccessStart});
     }
     else
@@ -493,12 +616,18 @@
                                        navAccessStart,
                                        ackTimeoutAccessStart,
                                        ctsTimeoutAccessStart,
+                                       usingOtherEmlsrLinkAccessStart,
                                        switchingAccessStart});
     }
+    std::stringstream ss;
+    if (m_usingOtherEmlsrLink)
+    {
+        ss << ", using other EMLSR link access start=" << usingOtherEmlsrLinkAccessStart;
+    }
     NS_LOG_INFO("access grant start=" << accessGrantedStart << ", rx access start=" << rxAccessStart
                                       << ", busy access start=" << busyAccessStart
                                       << ", tx access start=" << txAccessStart
-                                      << ", nav access start=" << navAccessStart);
+                                      << ", nav access start=" << navAccessStart << ss.str());
     return accessGrantedStart;
 }
 
@@ -751,13 +880,61 @@
 }
 
 void
-ChannelAccessManager::NotifySwitchingStartNow(Time duration)
+ChannelAccessManager::NotifySwitchingStartNow(PhyListener* phyListener, Time duration)
 {
-    NS_LOG_FUNCTION(this << duration);
+    NS_LOG_FUNCTION(this << phyListener << duration);
+
     Time now = Simulator::Now();
     NS_ASSERT(m_lastTxEnd <= now);
     NS_ASSERT(m_lastSwitchingEnd <= now);
 
+    if (phyListener) // to make tests happy
+    {
+        // check if the PHY switched channel to operate on another EMLSR link
+
+        for (const auto& [phyRef, listener] : m_phyListeners)
+        {
+            Ptr<WifiPhy> phy = phyRef;
+            auto emlsrInfoIt = m_switchingEmlsrLinks.find(phy);
+
+            if (listener.get() == phyListener && emlsrInfoIt != m_switchingEmlsrLinks.cend() &&
+                phy->GetOperatingChannel() == emlsrInfoIt->second.channel)
+            {
+                // the PHY associated with the given PHY listener switched channel to
+                // operate on another EMLSR link as expected. We don't need this listener
+                // anymore. The MAC will connect a new listener to the ChannelAccessManager
+                // instance associated with the link the PHY is now operating on
+                RemovePhyListener(phy);
+                auto ehtFem = DynamicCast<EhtFrameExchangeManager>(m_feManager);
+                NS_ASSERT(ehtFem);
+                ehtFem->NotifySwitchingEmlsrLink(phy, emlsrInfoIt->second.linkId, duration);
+                m_switchingEmlsrLinks.erase(emlsrInfoIt);
+                return;
+            }
+        }
+    }
+
+    ResetState();
+
+    // Reset backoffs
+    for (const auto& txop : m_txops)
+    {
+        ResetBackoff(txop);
+    }
+
+    // Notify the FEM, which will in turn notify the MAC
+    m_feManager->NotifySwitchingStartNow(duration);
+
+    NS_LOG_DEBUG("switching start for " << duration);
+    m_lastSwitchingEnd = now + duration;
+}
+
+void
+ChannelAccessManager::ResetState()
+{
+    NS_LOG_FUNCTION(this);
+
+    Time now = Simulator::Now();
     m_lastRxReceivedOk = true;
     UpdateLastIdlePeriod();
     m_lastRx.end = std::min(m_lastRx.end, now);
@@ -765,7 +942,6 @@
     m_lastAckTimeoutEnd = std::min(m_lastAckTimeoutEnd, now);
     m_lastCtsTimeoutEnd = std::min(m_lastCtsTimeoutEnd, now);
 
-    // the new operating channel may have a different width than the previous one
     InitLastBusyStructs();
 
     // Cancel timeout
@@ -773,25 +949,21 @@
     {
         m_accessTimeout.Cancel();
     }
+}
 
-    // Notify the FEM, which will in turn notify the MAC
-    m_feManager->NotifySwitchingStartNow(duration);
+void
+ChannelAccessManager::ResetBackoff(Ptr<Txop> txop)
+{
+    NS_LOG_FUNCTION(this << txop);
 
-    // Reset backoffs
-    for (auto txop : m_txops)
+    uint32_t remainingSlots = txop->GetBackoffSlots(m_linkId);
+    if (remainingSlots > 0)
     {
-        uint32_t remainingSlots = txop->GetBackoffSlots(m_linkId);
-        if (remainingSlots > 0)
-        {
-            txop->UpdateBackoffSlotsNow(remainingSlots, now, m_linkId);
-            NS_ASSERT(txop->GetBackoffSlots(m_linkId) == 0);
-        }
-        txop->ResetCw(m_linkId);
-        txop->GetLink(m_linkId).access = Txop::NOT_REQUESTED;
+        txop->UpdateBackoffSlotsNow(remainingSlots, Simulator::Now(), m_linkId);
+        NS_ASSERT(txop->GetBackoffSlots(m_linkId) == 0);
     }
-
-    NS_LOG_DEBUG("switching start for " << duration);
-    m_lastSwitchingEnd = now + duration;
+    txop->ResetCw(m_linkId);
+    txop->GetLink(m_linkId).access = Txop::NOT_REQUESTED;
 }
 
 void
@@ -837,14 +1009,7 @@
     m_sleeping = false;
     for (auto txop : m_txops)
     {
-        uint32_t remainingSlots = txop->GetBackoffSlots(m_linkId);
-        if (remainingSlots > 0)
-        {
-            txop->UpdateBackoffSlotsNow(remainingSlots, Simulator::Now(), m_linkId);
-            NS_ASSERT(txop->GetBackoffSlots(m_linkId) == 0);
-        }
-        txop->ResetCw(m_linkId);
-        txop->GetLink(m_linkId).access = Txop::NOT_REQUESTED;
+        ResetBackoff(txop);
         txop->NotifyWakeUp(m_linkId);
     }
 }
@@ -856,14 +1021,7 @@
     m_off = false;
     for (auto txop : m_txops)
     {
-        uint32_t remainingSlots = txop->GetBackoffSlots(m_linkId);
-        if (remainingSlots > 0)
-        {
-            txop->UpdateBackoffSlotsNow(remainingSlots, Simulator::Now(), m_linkId);
-            NS_ASSERT(txop->GetBackoffSlots(m_linkId) == 0);
-        }
-        txop->ResetCw(m_linkId);
-        txop->GetLink(m_linkId).access = Txop::NOT_REQUESTED;
+        ResetBackoff(txop);
         txop->NotifyOn();
     }
 }
@@ -925,10 +1083,38 @@
 }
 
 void
+ChannelAccessManager::NotifyStartUsingOtherEmlsrLink()
+{
+    NS_LOG_FUNCTION(this);
+    // update backoff if a PHY is operating on this link
+    if (m_phy)
+    {
+        UpdateBackoff();
+    }
+    // Cancel timeout
+    if (m_accessTimeout.IsRunning())
+    {
+        m_accessTimeout.Cancel();
+    }
+    m_usingOtherEmlsrLink = true;
+    UpdateLastIdlePeriod();
+}
+
+void
+ChannelAccessManager::NotifyStopUsingOtherEmlsrLink()
+{
+    NS_LOG_FUNCTION(this);
+    m_usingOtherEmlsrLink = false;
+    m_lastUsingOtherEmlsrLinkEnd = Simulator::Now();
+    DoRestartAccessTimeoutIfNeeded();
+}
+
+void
 ChannelAccessManager::UpdateLastIdlePeriod()
 {
     NS_LOG_FUNCTION(this);
-    Time idleStart = std::max({m_lastTxEnd, m_lastRx.end, m_lastSwitchingEnd});
+    Time idleStart =
+        std::max({m_lastTxEnd, m_lastRx.end, m_lastSwitchingEnd, m_lastUsingOtherEmlsrLinkEnd});
     Time now = Simulator::Now();
 
     if (idleStart >= now)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/channel-access-manager.h ns-3.40/src/wifi/model/channel-access-manager.h
--- ns-3.39/src/wifi/model/channel-access-manager.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/channel-access-manager.h	2023-09-27 13:30:37.902840000 -0700
@@ -21,6 +21,7 @@
 #define CHANNEL_ACCESS_MANAGER_H
 
 #include "wifi-phy-common.h"
+#include "wifi-phy-operating-channel.h"
 
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
@@ -28,6 +29,8 @@
 
 #include <algorithm>
 #include <map>
+#include <memory>
+#include <unordered_map>
 #include <vector>
 
 namespace ns3
@@ -60,18 +63,27 @@
     ~ChannelAccessManager() override;
 
     /**
-     * Set up listener for PHY events.
+     * Set up (or reactivate) listener for PHY events on the given PHY. The new (or reactivated)
+     * listener becomes the active listener and the previous active listener attached to another
+     * PHY, if any, is deactivated.
      *
      * \param phy the WifiPhy to listen to
      */
     void SetupPhyListener(Ptr<WifiPhy> phy);
     /**
-     * Remove current registered listener for PHY events.
+     * Remove current registered listener for PHY events on the given PHY.
      *
      * \param phy the WifiPhy to listen to
      */
     void RemovePhyListener(Ptr<WifiPhy> phy);
     /**
+     * Deactivate current registered listener for PHY events on the given PHY. All notifications
+     * but channel switch notifications coming from an inactive listener are ignored.
+     *
+     * \param phy the WifiPhy to listen to
+     */
+    void DeactivatePhyListener(Ptr<WifiPhy> phy);
+    /**
      * Set the ID of the link this Channel Access Manager is associated with.
      *
      * \param linkId the ID of the link this Channel Access Manager is associated with
@@ -195,13 +207,14 @@
                                WifiChannelListType channelType,
                                const std::vector<Time>& per20MhzDurations);
     /**
+     * \param phyListener the PHY listener that sent this notification
      * \param duration expected duration of channel switching period
      *
      * Notify the Txop that a channel switching period has just started.
      * During switching state, new packets can be enqueued in Txop/QosTxop
      * but they won't access to the medium until the end of the channel switching.
      */
-    void NotifySwitchingStartNow(Time duration);
+    void NotifySwitchingStartNow(PhyListener* phyListener, Time duration);
     /**
      * Notify the Txop that the device has been put in sleep mode.
      */
@@ -252,6 +265,15 @@
     void NotifyCtsTimeoutResetNow();
 
     /**
+     * Notify that another EMLSR link is being used, hence medium access should be disabled.
+     */
+    void NotifyStartUsingOtherEmlsrLink();
+    /**
+     * Notify that another EMLSR link is no longer being used, hence medium access can be resumed.
+     */
+    void NotifyStopUsingOtherEmlsrLink();
+
+    /**
      * Check if the device is busy sending or receiving,
      * or NAV or CCA busy.
      *
@@ -260,12 +282,43 @@
      */
     bool IsBusy() const;
 
+    /**
+     * Reset the state variables of this channel access manager.
+     */
+    void ResetState();
+    /**
+     * Reset the backoff for the given DCF/EDCAF.
+     *
+     * \param txop the given DCF/EDCAF
+     */
+    void ResetBackoff(Ptr<Txop> txop);
+
+    /**
+     * Notify that the given PHY is about to switch to the given operating channel, which is
+     * used by the given link. This notification is sent by the EMLSR Manager when a PHY object
+     * switches operating channel to operate on another link.
+     *
+     * \param phy the PHY object that is going to switch channel
+     * \param channel the new operating channel of the given PHY
+     * \param linkId the ID of the link on which the given PHY is going to operate
+     */
+    void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy,
+                                  const WifiPhyOperatingChannel& channel,
+                                  uint8_t linkId);
+
   protected:
     void DoInitialize() override;
     void DoDispose() override;
 
   private:
     /**
+     * Get current registered listener for PHY events on the given PHY.
+     *
+     * \param phy the given PHY
+     * \return the current registered listener for PHY events on the given PHY
+     */
+    PhyListener* GetPhyListener(Ptr<WifiPhy> phy) const;
+    /**
      * Initialize the structures holding busy end times per channel type (primary,
      * secondary, etc.) and per 20 MHz channel.
      */
@@ -360,14 +413,31 @@
     std::vector<Time> m_lastPer20MHzBusyEnd; /**< the last busy end time per 20 MHz channel
                                                   (HE stations and channel width > 20 MHz only) */
     std::map<WifiChannelListType, Timespan>
-        m_lastIdle;             //!< the last idle start and end time for each channel type
-    Time m_lastSwitchingEnd;    //!< the last switching end time
-    bool m_sleeping;            //!< flag whether it is in sleeping state
-    bool m_off;                 //!< flag whether it is in off state
-    Time m_eifsNoDifs;          //!< EIFS no DIFS time
-    EventId m_accessTimeout;    //!< the access timeout ID
-    PhyListener* m_phyListener; //!< the PHY listener
-    Ptr<WifiPhy> m_phy;         //!< pointer to the PHY
+        m_lastIdle;                    //!< the last idle start and end time for each channel type
+    Time m_lastSwitchingEnd;           //!< the last switching end time
+    bool m_usingOtherEmlsrLink;        //!< whether another EMLSR link is being used
+    Time m_lastUsingOtherEmlsrLinkEnd; //!< the last time we were blocked because using another
+                                       //!< EMLSR link
+    bool m_sleeping;                   //!< flag whether it is in sleeping state
+    bool m_off;                        //!< flag whether it is in off state
+    Time m_eifsNoDifs;                 //!< EIFS no DIFS time
+    EventId m_accessTimeout;           //!< the access timeout ID
+
+    /// Information associated with each PHY that is going to operate on another EMLSR link
+    struct EmlsrLinkSwitchInfo
+    {
+        WifiPhyOperatingChannel channel; //!< new operating channel
+        uint8_t linkId; //!< ID of the EMLSR link on which the PHY is going to operate
+    };
+
+    /// Store information about the PHY objects that are going to operate on another EMLSR link
+    std::unordered_map<Ptr<WifiPhy>, EmlsrLinkSwitchInfo> m_switchingEmlsrLinks;
+
+    /// Maps each PHY listener to the associated PHY
+    using PhyListenerMap = std::unordered_map<Ptr<WifiPhy>, std::unique_ptr<PhyListener>>;
+
+    PhyListenerMap m_phyListeners;         //!< the PHY listeners
+    Ptr<WifiPhy> m_phy;                    //!< pointer to the unique active PHY
     Ptr<FrameExchangeManager> m_feManager; //!< pointer to the Frame Exchange Manager
     uint8_t m_linkId;                      //!< the ID of the link this object is associated with
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/ctrl-headers.cc ns-3.40/src/wifi/model/ctrl-headers.cc
--- ns-3.39/src/wifi/model/ctrl-headers.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/ctrl-headers.cc	2023-09-27 13:30:37.902840000 -0700
@@ -232,7 +232,7 @@
 uint8_t
 CtrlBAckRequestHeader::GetTidInfo() const
 {
-    uint8_t tid = static_cast<uint8_t>(m_tidInfo);
+    auto tid = static_cast<uint8_t>(m_tidInfo);
     return tid;
 }
 
@@ -1451,7 +1451,8 @@
 void
 CtrlTriggerUserInfoField::SetUlMcs(uint8_t mcs)
 {
-    NS_ABORT_MSG_IF(mcs > 11, "Invalid MCS index");
+    uint8_t maxMcs = m_variant == TriggerFrameVariant::EHT ? 13 : 11;
+    NS_ABORT_MSG_IF(mcs > maxMcs, "Invalid MCS index");
     m_ulMcs = mcs;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/edca-parameter-set.cc ns-3.40/src/wifi/model/edca-parameter-set.cc
--- ns-3.39/src/wifi/model/edca-parameter-set.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/edca-parameter-set.cc	2023-09-27 13:30:37.902840000 -0700
@@ -61,14 +61,14 @@
 void
 EdcaParameterSet::SetBeCWmin(uint32_t cwMin)
 {
-    uint8_t ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
+    auto ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
     m_acBE |= (ECWmin & 0x0f) << 8;
 }
 
 void
 EdcaParameterSet::SetBeCWmax(uint32_t cwMax)
 {
-    uint8_t ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
+    auto ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
     m_acBE |= (ECWmax & 0x0f) << 12;
 }
 
@@ -93,14 +93,14 @@
 void
 EdcaParameterSet::SetBkCWmin(uint32_t cwMin)
 {
-    uint8_t ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
+    auto ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
     m_acBK |= (ECWmin & 0x0f) << 8;
 }
 
 void
 EdcaParameterSet::SetBkCWmax(uint32_t cwMax)
 {
-    uint8_t ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
+    auto ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
     m_acBK |= (ECWmax & 0x0f) << 12;
 }
 
@@ -125,14 +125,14 @@
 void
 EdcaParameterSet::SetViCWmin(uint32_t cwMin)
 {
-    uint8_t ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
+    auto ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
     m_acVI |= (ECWmin & 0x0f) << 8;
 }
 
 void
 EdcaParameterSet::SetViCWmax(uint32_t cwMax)
 {
-    uint8_t ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
+    auto ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
     m_acVI |= (ECWmax & 0x0f) << 12;
 }
 
@@ -157,14 +157,14 @@
 void
 EdcaParameterSet::SetVoCWmin(uint32_t cwMin)
 {
-    uint8_t ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
+    auto ECWmin = static_cast<uint8_t>(log2(cwMin + 1));
     m_acVO |= (ECWmin & 0x0f) << 8;
 }
 
 void
 EdcaParameterSet::SetVoCWmax(uint32_t cwMax)
 {
-    uint8_t ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
+    auto ECWmax = static_cast<uint8_t>(log2(cwMax + 1));
     m_acVO |= (ECWmax & 0x0f) << 12;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/default-emlsr-manager.cc ns-3.40/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.39/src/wifi/model/eht/default-emlsr-manager.cc	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/default-emlsr-manager.cc	2023-09-27 13:30:37.902840000 -0700
@@ -19,8 +19,11 @@
 
 #include "default-emlsr-manager.h"
 
+#include "ns3/boolean.h"
+#include "ns3/channel-access-manager.h"
 #include "ns3/log.h"
 #include "ns3/wifi-mpdu.h"
+#include "ns3/wifi-phy.h"
 
 namespace ns3
 {
@@ -32,10 +35,17 @@
 TypeId
 DefaultEmlsrManager::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::DefaultEmlsrManager")
-                            .SetParent<EmlsrManager>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<DefaultEmlsrManager>();
+    static TypeId tid =
+        TypeId("ns3::DefaultEmlsrManager")
+            .SetParent<EmlsrManager>()
+            .SetGroupName("Wifi")
+            .AddConstructor<DefaultEmlsrManager>()
+            .AddAttribute("SwitchAuxPhy",
+                          "Whether Aux PHY should switch channel to operate on the link on which "
+                          "the Main PHY was operating before moving to the link of the Aux PHY.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&DefaultEmlsrManager::m_switchAuxPhy),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -53,27 +63,24 @@
 DefaultEmlsrManager::DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << *mpdu << linkId);
-
-    if (mpdu->GetHeader().IsAssocResp() && GetStaMac()->IsAssociated() && GetTransitionTimeout())
-    {
-        m_assocLinkId = linkId;
-    }
 }
 
 uint8_t
-DefaultEmlsrManager::GetLinkToSendEmlNotification()
+DefaultEmlsrManager::GetLinkToSendEmlOmn()
 {
     NS_LOG_FUNCTION(this);
-    NS_ASSERT_MSG(m_assocLinkId, "No recorded link on which Assoc Response was received");
-    return *m_assocLinkId;
+    auto linkId = GetStaMac()->GetLinkForPhy(m_mainPhyId);
+    NS_ASSERT_MSG(linkId, "Link on which the main PHY is operating not found");
+    return *linkId;
 }
 
 std::optional<uint8_t>
 DefaultEmlsrManager::ResendNotification(Ptr<const WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this);
-    NS_ASSERT_MSG(m_assocLinkId, "No recorded link on which Assoc Response was received");
-    return *m_assocLinkId;
+    auto linkId = GetStaMac()->GetLinkForPhy(m_mainPhyId);
+    NS_ASSERT_MSG(linkId, "Link on which the main PHY is operating not found");
+    return *linkId;
 }
 
 void
@@ -82,4 +89,30 @@
     NS_LOG_FUNCTION(this);
 }
 
+void
+DefaultEmlsrManager::NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId)
+{
+    NS_LOG_FUNCTION(this << currLinkId << nextLinkId);
+
+    if (!m_switchAuxPhy)
+    {
+        return; // nothing to do
+    }
+
+    // switch channel on Aux PHY so that it operates on the link on which the main PHY was operating
+    auto auxPhy = GetStaMac()->GetWifiPhy(nextLinkId);
+
+    auto newAuxPhyChannel = GetChannelForAuxPhy(currLinkId);
+
+    NS_LOG_DEBUG("Aux PHY (" << auxPhy << ") is about to switch to " << newAuxPhyChannel
+                             << " to operate on link " << +currLinkId);
+
+    GetStaMac()
+        ->GetChannelAccessManager(nextLinkId)
+        ->NotifySwitchingEmlsrLink(auxPhy, newAuxPhyChannel, currLinkId);
+
+    void (WifiPhy::*fp)(const WifiPhyOperatingChannel&) = &WifiPhy::SetOperatingChannel;
+    Simulator::ScheduleNow(fp, auxPhy, newAuxPhyChannel);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/eht/default-emlsr-manager.h ns-3.40/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.39/src/wifi/model/eht/default-emlsr-manager.h	2023-07-05 14:23:48.109428400 -0700
+++ ns-3.40/src/wifi/model/eht/default-emlsr-manager.h	2023-09-27 13:30:37.902840000 -0700
@@ -45,15 +45,16 @@
     ~DefaultEmlsrManager() override;
 
   protected:
-    uint8_t GetLinkToSendEmlNotification() override;
+    uint8_t GetLinkToSendEmlOmn() override;
     std::optional<uint8_t> ResendNotification(Ptr<const WifiMpdu> mpdu) override;
 
   private:
     void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     void NotifyEmlsrModeChanged() override;
+    void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) override;
 
-    std::optional<uint8_t> m_assocLinkId; /**< ID of the link on which Association Response
-                                               was received */
+    bool m_switchAuxPhy; /**< whether Aux PHY should switch channel to operate on the link on which
+                              the Main PHY was operating before moving to the link of the Aux PHY */
 };
 
 } // namespace ns3
